pcl::NarfKeypoint Class Reference
Module keypoints

NARF (Normal Aligned Radial Feature) keypoints. More...

`#include <pcl/keypoints/narf_keypoint.h>`

Inheritance diagram for pcl::NarfKeypoint:

## Classes

struct | Parameters
| Parameters used in this class. More...

## Public Types

typedef boost::shared_ptr< NarfKeypoint > | Ptr
typedef boost::shared_ptr< const NarfKeypoint > | ConstPtr
typedef Keypoint< PointWithRange, int > | BaseClass
typedef Keypoint< PointWithRange, int >::PointCloudOut | PointCloudOut
Public Types inherited from pcl::Keypoint< PointWithRange, int >
typedef boost::shared_ptr< Keypoint< PointWithRange, int > > | Ptr
typedef boost::shared_ptr< const Keypoint< PointWithRange, int > > | ConstPtr
typedef PCLBase< PointWithRange > | BaseClass
typedef pcl::search::Search< PointWithRange > | KdTree
typedef pcl::search::Search< PointWithRange >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointWithRange > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< int > | PointCloudOut
typedef boost::function< int(int, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, int index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointWithRange >
typedef pcl::PointCloud< PointWithRange > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| NarfKeypoint (RangeImageBorderExtractor *range_image_border_extractor=NULL, float support_size=-1.0f)
virtual | ~NarfKeypoint ()
void | clearData ()
| Erase all data calculated for the current range image. More...
void | setRangeImageBorderExtractor (RangeImageBorderExtractor *range_image_border_extractor)
| Set the RangeImageBorderExtractor member (required) More...
RangeImageBorderExtractor * | getRangeImageBorderExtractor ()
| Get the RangeImageBorderExtractor member. More...
void | setRangeImage (const RangeImage *range_image)
| Set the RangeImage member of the RangeImageBorderExtractor. More...
float * | getInterestImage ()
| Extract interest value per image point. More...
const ::pcl::PointCloud< InterestPoint > & | getInterestPoints ()
| Extract maxima from an interest image. More...
const std::vector< bool > & | getIsInterestPointImage ()
| Set all points in the image that are interest points to true, the rest to false. More...
Parameters & | getParameters ()
| Getter for the parameter struct. More...
const RangeImage & | getRangeImage ()
| Getter for the range image of range_image_border_extractor_. More...
void | compute (PointCloudOut &output)
| Overwrite the compute function of the base class. More...
Public Member Functions inherited from pcl::Keypoint< PointWithRange, int >
| Keypoint ()
| Empty constructor. More...
virtual | ~Keypoint ()
| Empty destructor. More...
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to the input dataset that we need to estimate features at every point for. More...
PointCloudInConstPtr | getSearchSurface ()
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
double | getSearchParameter ()
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch ()
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection. More...
double | getRadiusSearch ()
| Get the sphere radius used for determining the neighbors. More...
pcl::PointIndicesConstPtr | getKeypointsIndices ()
void | compute (PointCloudOut &output)
| Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
int | searchForNeighbors (int index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Public Member Functions inherited from pcl::PCLBase< PointWithRange >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointWithRange & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | calculateScaleSpace ()
void | calculateInterestImage ()
void | calculateCompleteInterestImage ()
void | calculateSparseInterestImage ()
void | calculateInterestPoints ()
virtual void | detectKeypoints (PointCloudOut &output)
| Detect key points. More...
Protected Member Functions inherited from pcl::Keypoint< PointWithRange, int >
virtual bool | initCompute ()
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual void | detectKeypoints (PointCloudOut &output)=0
| Abstract key point detection method. More...
Protected Member Functions inherited from pcl::PCLBase< PointWithRange >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

RangeImageBorderExtractor * | range_image_border_extractor_
Parameters | parameters_
float * | interest_image_
::pcl::PointCloud< InterestPoint > * | interest_points_
std::vector< bool > | is_interest_point_image_
std::vector< RangeImage * > | range_image_scale_space_
std::vector< RangeImageBorderExtractor * > | border_extractor_scale_space_
std::vector< float * > | interest_image_scale_space_
Protected Attributes inherited from pcl::Keypoint< PointWithRange, int >
std::string | name_
| The key point detection method's name. More...
SearchMethod | search_method_
| The search method template for indices. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (casted from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
pcl::PointIndicesPtr | keypoints_indices_
| Indices of the keypoints in the input cloud. More...
Protected Attributes inherited from pcl::PCLBase< PointWithRange >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

NARF (Normal Aligned Radial Feature) keypoints.

Input is a range image, output the indices of the keypoints See B. Steder, R. B. Rusu, K. Konolige, and W. Burgard Point Feature Extraction on 3D Range Scans Taking into Account Object Boundaries In Proc. of the IEEE Int. Conf. on Robotics &Automation (ICRA). 2011.

Author
  Bastian Steder

Definition at line 60 of file narf_keypoint.h.

## Member Typedef Documentation

typedef Keypoint<PointWithRange, int> pcl::NarfKeypoint::BaseClass

Definition at line 67 of file narf_keypoint.h.

typedef boost::shared_ptr<const NarfKeypoint> pcl::NarfKeypoint::ConstPtr

Definition at line 64 of file narf_keypoint.h.

typedef Keypoint<PointWithRange, int>::PointCloudOut pcl::NarfKeypoint::PointCloudOut

Definition at line 69 of file narf_keypoint.h.

typedef boost::shared_ptr<NarfKeypoint> pcl::NarfKeypoint::Ptr

Definition at line 63 of file narf_keypoint.h.

## Constructor & Destructor Documentation

pcl::NarfKeypoint::NarfKeypoint | ( | RangeImageBorderExtractor * | range_image_border_extractor = `NULL`,
|  | float | support_size = `-1.0f`
| ) |  |

virtual pcl::NarfKeypoint::~NarfKeypoint | ( |  | ) |

virtual

## Member Function Documentation

void pcl::NarfKeypoint::calculateCompleteInterestImage | ( |  | ) |

protected

void pcl::NarfKeypoint::calculateInterestImage | ( |  | ) |

protected

void pcl::NarfKeypoint::calculateInterestPoints | ( |  | ) |

protected

void pcl::NarfKeypoint::calculateScaleSpace | ( |  | ) |

protected

void pcl::NarfKeypoint::calculateSparseInterestImage | ( |  | ) |

protected

void pcl::NarfKeypoint::clearData | ( |  | ) |

Erase all data calculated for the current range image.

void pcl::NarfKeypoint::compute | ( | PointCloudOut & | output | ) |

Overwrite the compute function of the base class.

virtual void pcl::NarfKeypoint::detectKeypoints | ( | PointCloudOut & | output | ) |

protected virtual

Detect key points.

float* pcl::NarfKeypoint::getInterestImage | ( |  | ) |

inline

Extract interest value per image point.

Definition at line 141 of file narf_keypoint.h.

const ::pcl::PointCloud<InterestPoint>& pcl::NarfKeypoint::getInterestPoints | ( |  | ) |

inline

Extract maxima from an interest image.

Definition at line 145 of file narf_keypoint.h.

const std::vector<bool>& pcl::NarfKeypoint::getIsInterestPointImage | ( |  | ) |

inline

Set all points in the image that are interest points to true, the rest to false.

Definition at line 149 of file narf_keypoint.h.

Parameters& pcl::NarfKeypoint::getParameters | ( |  | ) |

inline

Getter for the parameter struct.

Definition at line 153 of file narf_keypoint.h.

const RangeImage& pcl::NarfKeypoint::getRangeImage | ( |  | ) |

Getter for the range image of range_image_border_extractor_.

RangeImageBorderExtractor* pcl::NarfKeypoint::getRangeImageBorderExtractor | ( |  | ) |

inline

Get the RangeImageBorderExtractor member.

Definition at line 133 of file narf_keypoint.h.

void pcl::NarfKeypoint::setRangeImage | ( | const RangeImage * | range_image | ) |

Set the RangeImage member of the RangeImageBorderExtractor.

void pcl::NarfKeypoint::setRangeImageBorderExtractor | ( | RangeImageBorderExtractor * | range_image_border_extractor | ) |

Set the RangeImageBorderExtractor member (required)

## Member Data Documentation

std::vector<RangeImageBorderExtractor*> pcl::NarfKeypoint::border_extractor_scale_space_

protected

Definition at line 189 of file narf_keypoint.h.

float* pcl::NarfKeypoint::interest_image_

protected

Definition at line 185 of file narf_keypoint.h.

std::vector<float*> pcl::NarfKeypoint::interest_image_scale_space_

protected

Definition at line 190 of file narf_keypoint.h.

::pcl::PointCloud<InterestPoint>* pcl::NarfKeypoint::interest_points_

protected

Definition at line 186 of file narf_keypoint.h.

std::vector<bool> pcl::NarfKeypoint::is_interest_point_image_

protected

Definition at line 187 of file narf_keypoint.h.

Parameters pcl::NarfKeypoint::parameters_

protected

Definition at line 184 of file narf_keypoint.h.

RangeImageBorderExtractor* pcl::NarfKeypoint::range_image_border_extractor_

protected

Definition at line 183 of file narf_keypoint.h.

std::vector<RangeImage*> pcl::NarfKeypoint::range_image_scale_space_

protected

Definition at line 188 of file narf_keypoint.h.

The documentation for this class was generated from the following file:

- /build/pcl-0nnAvv/pcl-1.7.2/keypoints/include/pcl/keypoints/narf_keypoint.h